Index: src/main/groovy/org/gradle/api/DebugHelper.java
===================================================================
--- src/main/groovy/org/gradle/api/DebugHelper.java	(revision 0)
+++ src/main/groovy/org/gradle/api/DebugHelper.java	(revision 0)
@@ -0,0 +1,81 @@
+/*=============================================================================
+                    AUTOMATED LOGIC CORPORATION
+            Copyright (c) 1999 - 2009 All Rights Reserved
+     This document contains confidential/proprietary information.
+===============================================================================
+
+   @(#)DebugHelper
+
+   Author(s) jmurph
+   $Log: $    
+=============================================================================*/
+package org.gradle;
+
+import org.gradle.api.internal.artifacts.dsl.AddSourceFileFieldForDebug;
+import org.gradle.groovy.scripts.FileScriptSource;
+
+import java.io.File;
+
+import com.sun.jdi.ReferenceType;
+import com.sun.jdi.Field;
+import com.sun.jdi.Value;
+import com.sun.jdi.StringReference;
+
+/**
+ * This class exists for use by external tools (IDEs) to support debugging
+ * of Gradle scripts.  Do not move or rename it as this will break such tools.
+ * Because such tools are expected to use reflection to access this class,
+ * changing the names or signatures of methods may also break such tools.
+ *
+ * By using this class, external tools can avoid making assumptions about the
+ * operation of Gradle, which means that Gradle can be modified without breaking
+ * the debugging support of such tools. 
+ */
+public class DebugHelper
+{
+    private DebugHelper() {}
+
+    /**
+     * Gradle compiles scripts into classes for execution within the Java VM.  A
+     * debugger needs to know what class name will be generated for a given script
+     * so that break points can be registered with the VM.
+     *
+     * @param scriptFile the script file for which the class name is desired.  Cannot
+     *        be null.
+     * @return the fully qualified class name of the generated script.  Currently
+     *         Gradle always generates scripts into the default package, but that
+     *         should not be assumed.  If the given scriptFile cannot be turned into
+     *         a class (because it does not exist, for example) then null is returned.
+     */
+    public static String getClassNameForScript(File scriptFile) {
+        assert scriptFile != null;
+
+        FileScriptSource source = new FileScriptSource("debug helper", scriptFile);
+        return source.getClassName();
+    }
+
+    /**
+     * For a class in the remote VM (using the Java Debugging APIs), determine the
+     * Gradle source script.  This allows a debugger to show the source file for
+     * the given reference type.
+     *
+     * @param refType The class in the remote VM.  Cannot be null.
+     * @return the script file for this class.  It is possible that the returned
+     *         file object does not represent a actual file (i.e. exists() might
+     *         return false).  If the script file cannot be determined, null is
+     *         returned.
+     */
+    public static File getScriptFromClass(ReferenceType refType) {
+        assert refType != null;
+
+        String sourceFileFieldName = AddSourceFileFieldForDebug.FIELD_NAME;
+        Field sourceFileField = refType.fieldByName(sourceFileFieldName);
+        if (sourceFileField == null)
+            return null;
+
+        Value sourceFileValue = refType.getValue(sourceFileField);
+        String sourceFilePath = ((StringReference)sourceFileValue).value();
+        return new File(sourceFilePath);
+    }
+}
+
Index: src/main/groovy/org/gradle/api/internal/artifacts/dsl/AddSourceFileFieldForDebug.java
===================================================================
--- src/main/groovy/org/gradle/api/internal/artifacts/dsl/AddSourceFileFieldForDebug.java	(revision 0)
+++ src/main/groovy/org/gradle/api/internal/artifacts/dsl/AddSourceFileFieldForDebug.java	(revision 0)
@@ -0,0 +1,35 @@
+/*=============================================================================
+                    AUTOMATED LOGIC CORPORATION
+            Copyright (c) 1999 - 2009 All Rights Reserved
+     This document contains confidential/proprietary information.
+===============================================================================
+
+   @(#)AddFieldForDebug
+
+   Author(s) jmurph
+   $Log: $    
+=============================================================================*/
+package org.gradle.api.internal.artifacts.dsl;
+
+import org.codehaus.groovy.control.CompilationUnit;
+import org.codehaus.groovy.control.SourceUnit;
+import org.codehaus.groovy.control.CompilationFailedException;
+import org.codehaus.groovy.classgen.GeneratorContext;
+import org.codehaus.groovy.ast.ClassNode;
+import org.codehaus.groovy.ast.ClassHelper;
+import org.codehaus.groovy.ast.expr.ConstantExpression;
+
+public class AddSourceFileFieldForDebug extends CompilationUnit.PrimaryClassNodeOperation
+{
+    public static final String FIELD_NAME = "__SOURCE_FILE";
+    private final String path;
+
+    public AddSourceFileFieldForDebug(String path) {
+        this.path = path;
+    }
+
+    public void call(SourceUnit sourceUnit, GeneratorContext generatorContext, ClassNode classNode) throws CompilationFailedException {
+        classNode.addField(FIELD_NAME, groovyjarjarasm.asm.Opcodes.ACC_PRIVATE | groovyjarjarasm.asm.Opcodes.ACC_STATIC | groovyjarjarasm.asm.Opcodes.ACC_FINAL | groovyjarjarasm.asm.Opcodes.ACC_TRANSIENT, ClassHelper.STRING_TYPE, new ConstantExpression(path));
+    }
+}
+
Index: src/main/groovy/org/gradle/configuration/BuildScriptCompiler.java
===================================================================
--- src/main/groovy/org/gradle/configuration/BuildScriptCompiler.java	(revision 1596)
+++ src/main/groovy/org/gradle/configuration/BuildScriptCompiler.java	(working copy)
@@ -1,54 +1,59 @@
-/*
- * Copyright 2009 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.configuration;
-
-import org.gradle.api.internal.project.ProjectInternal;
-import org.gradle.api.internal.project.ProjectScript;
-import org.gradle.api.internal.project.ImportsReader;
-import org.gradle.api.internal.artifacts.dsl.TaskDefinitionScriptTransformer;
-import org.gradle.api.internal.artifacts.dsl.BuildScriptClasspathScriptTransformer;
-import org.gradle.groovy.scripts.*;
-import groovy.lang.Script;
-
-public class BuildScriptCompiler implements ProjectEvaluator {
-    private final ImportsReader importsReader;
-    private final ScriptProcessorFactory scriptProcessorFactory;
-    private final IProjectScriptMetaData projectScriptMetaData;
-
-    public BuildScriptCompiler(ImportsReader importsReader, ScriptProcessorFactory scriptProcessorFactory,
-                               IProjectScriptMetaData projectScriptMetaData) {
-        this.importsReader = importsReader;
-        this.scriptProcessorFactory = scriptProcessorFactory;
-        this.projectScriptMetaData = projectScriptMetaData;
-    }
-
-    public void evaluate(ProjectInternal project) {
-        ScriptSource source = new ImportsScriptSource(project.getBuildScriptSource(), importsReader,
-                project.getRootDir());
-        ScriptProcessor processor = scriptProcessorFactory.createProcessor(source);
-        processor.setClassloader(project.getBuildScriptClassLoader());
-
-        processor.setTransformer(new BuildScriptClasspathScriptTransformer());
-        Script classPathScript = processor.process(ProjectScript.class);
-        projectScriptMetaData.applyMetaData(classPathScript, project);
-        classPathScript.run();
-
-        processor.setTransformer(new TaskDefinitionScriptTransformer());
-        Script buildScript = processor.process(ProjectScript.class);
-        projectScriptMetaData.applyMetaData(buildScript, project);
-        project.setBuildScript(buildScript);
-    }
-}
+/*
+ * Copyright 2009 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.configuration;
+
+import org.gradle.api.internal.project.ProjectInternal;
+import org.gradle.api.internal.project.ProjectScript;
+import org.gradle.api.internal.project.ImportsReader;
+import org.gradle.api.internal.artifacts.dsl.TaskDefinitionScriptTransformer;
+import org.gradle.api.internal.artifacts.dsl.BuildScriptClasspathScriptTransformer;
+import org.gradle.groovy.scripts.*;
+import org.gradle.api.internal.artifacts.dsl.AddSourceFileFieldForDebug;
+import groovy.lang.Script;
+
+public class BuildScriptCompiler implements ProjectEvaluator {
+    private final ImportsReader importsReader;
+    private final ScriptProcessorFactory scriptProcessorFactory;
+    private final IProjectScriptMetaData projectScriptMetaData;
+
+    public BuildScriptCompiler(ImportsReader importsReader, ScriptProcessorFactory scriptProcessorFactory,
+                               IProjectScriptMetaData projectScriptMetaData) {
+        this.importsReader = importsReader;
+        this.scriptProcessorFactory = scriptProcessorFactory;
+        this.projectScriptMetaData = projectScriptMetaData;
+    }
+
+    public void evaluate(ProjectInternal project) {
+        ScriptSource source = new ImportsScriptSource(project.getBuildScriptSource(), importsReader,
+                project.getRootDir());
+        ScriptProcessor processor = scriptProcessorFactory.createProcessor(source);
+        processor.setClassloader(project.getBuildScriptClassLoader());
+
+        processor.addTransformer(new BuildScriptClasspathScriptTransformer());
+        Script classPathScript = processor.process(ProjectScript.class);
+        projectScriptMetaData.applyMetaData(classPathScript, project);
+        classPathScript.run();
+
+        processor.clearTransformers();
+        processor.addTransformer(new TaskDefinitionScriptTransformer());
+        String path = source.getSourceFileCanonicalPath();
+        if (path != null)
+            processor.addTransformer(new AddSourceFileFieldForDebug(path));
+        Script buildScript = processor.process(ProjectScript.class);
+        projectScriptMetaData.applyMetaData(buildScript, project);
+        project.setBuildScript(buildScript);
+    }
+}
Index: src/main/groovy/org/gradle/groovy/scripts/CachePropertiesHandler.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/CachePropertiesHandler.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/CachePropertiesHandler.java	(working copy)
@@ -1,33 +1,34 @@
-/*
- * Copyright 2007-2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import java.io.File;
-
-/**
- * @author Hans Dockter
- */
-public interface CachePropertiesHandler {
-    String HASH_KEY = "hash";
-    String PROPERTY_FILE_NAME = "cache.properties";
-    String VERSION_KEY = "version";
-
-    enum CacheState { VALID, INVALID }
-
-    void writeProperties(String scriptText, File scriptCacheDir);
-
-    CacheState getCacheState(String testScript, File scriptCacheDir);
-}
+/*
+ * Copyright 2007-2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import java.io.File;
+
+/**
+ * @author Hans Dockter
+ */
+public interface CachePropertiesHandler {
+    String HASH_KEY = "hash";
+    String PROPERTY_FILE_NAME = "cache.properties";
+    String VERSION_KEY = "version";
+    String SOURCEFILE_KEY = "sourcefile";
+
+    enum CacheState { VALID, INVALID }
+
+    void writeProperties(ScriptSource script, File scriptCacheDir);
+
+    CacheState getCacheState(ScriptSource script, File scriptCacheDir);
+}
Index: src/main/groovy/org/gradle/groovy/scripts/DefaultCachePropertiesHandler.java
===================================================================
--- src/main/groovy/org/gradle/groovy/scripts/DefaultCachePropertiesHandler.java	(revision 1596)
+++ src/main/groovy/org/gradle/groovy/scripts/DefaultCachePropertiesHandler.java	(working copy)
@@ -1,54 +1,67 @@
-/*
- * Copyright 2007-2008 the original author or authors.
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *      http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-package org.gradle.groovy.scripts;
-
-import org.gradle.util.GUtil;
-import org.gradle.util.GradleVersion;
-import org.gradle.util.HashUtil;
-
-import java.io.File;
-import java.util.Properties;
-
-/**
- * @author Hans Dockter
- */
-public class DefaultCachePropertiesHandler implements CachePropertiesHandler {
-    public void writeProperties(String scriptText, File scriptCacheDir) {
-        assert scriptText != null;
-
-        Properties properties = new Properties();
-        properties.put(CachePropertiesHandler.HASH_KEY, HashUtil.createHash(scriptText));
-        properties.put(CachePropertiesHandler.VERSION_KEY, new GradleVersion().getVersion());
-        
-        GUtil.saveProperties(properties, new File(scriptCacheDir, CachePropertiesHandler.PROPERTY_FILE_NAME));
-    }
-
-    public CacheState getCacheState(String scriptText, File scriptCacheDir) {
-        assert scriptText != null;
-        
-        File propertiesFile = new File(scriptCacheDir, CachePropertiesHandler.PROPERTY_FILE_NAME);
-        if (!propertiesFile.isFile()) {
-            return CacheState.INVALID;
-        }
-        Properties properties = GUtil.loadProperties(new File(scriptCacheDir, CachePropertiesHandler.PROPERTY_FILE_NAME));
-
-        if (!properties.get(CachePropertiesHandler.VERSION_KEY).equals(new GradleVersion().getVersion())) {
-            return CacheState.INVALID;
-        }
-        return HashUtil.createHash(scriptText).equals(properties.get(CachePropertiesHandler.HASH_KEY)) ?
-                CacheState.VALID : CacheState.INVALID;
-    }
-}
+/*
+ * Copyright 2007-2008 the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.gradle.groovy.scripts;
+
+import org.gradle.util.GUtil;
+import org.gradle.util.GradleVersion;
+import org.gradle.util.HashUtil;
+
+import java.io.File;
+import java.util.Properties;
+
+/**
+ * @author Hans Dockter
+ */
+public class DefaultCachePropertiesHandler implements CachePropertiesHandler {
+    public void writeProperties(ScriptSource script, File scriptCacheDir) {
+        assert script != null && script.getText() != null;
+
+        Properties properties = new Properties();
+        properties.put(CachePropertiesHandler.HASH_KEY, HashUtil.createHash(script.getText()));
+        properties.put(CachePropertiesHandler.VERSION_KEY, new GradleVersion().getVersion());
+
+        String path = script.getSourceFileCanonicalPath();
+        if (path != null) {
+            properties.put(CachePropertiesHandler.SOURCEFILE_KEY, path);
+        }
+
+        GUtil.saveProperties(properties, new File(scriptCacheDir, CachePropertiesHandler.PROPERTY_FILE_NAME));
+    }
+
+    public CacheState getCacheState(ScriptSource script, File scriptCacheDir) {
+        assert script != null && script.getText() != null;
+
+        File propertiesFile = new File(scriptCacheDir, CachePropertiesHandler.PROPERTY_FILE_NAME);
+        if (!propertiesFile.isFile()) {
+            return CacheState.INVALID;
+        }
+
+        Properties properties = GUtil.loadProperties(propertiesFile);
+
+        if (!properties.get(CachePropertiesHandler.VERSION_KEY).equals(new GradleVersion().getVersion())) {
+            return CacheState.INVALID;
+        }
+
+        String path = script.getSourceFileCanonicalPath();
+        String cachedPath = properties.getProperty(CachePropertiesHandler.SOURCEFILE_KEY);
+        if ((path == null && cachedPath != null) || (path != null && !path.equals(cachedPath))) {
+            return CacheState.INVALID;
+        }
+
+        return HashUtil.createHash(script.getText()).equals(properties.get(CachePropertiesHandler.HASH_KEY)) ?
+            CacheState.VALID : CacheState.INVALID;
+    }
+}
